using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_WorkFile
    /// </summary>
    public partial class T_Sys_WorkFile
    {
        public T_Sys_WorkFile()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_FileId", "T_Sys_WorkFile");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(string F_WorkOrderId, int F_FileId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_WorkFile");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId and F_FileId=@F_FileId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)          };
            parameters[0].Value = F_WorkOrderId;
            parameters[1].Value = F_FileId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(CallCenterApi.Model.T_Sys_WorkFile model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_WorkFile(");
            strSql.Append("F_WorkOrderId,F_FileId,F_Type,F_Id)");
            strSql.Append(" values (");
            strSql.Append("@F_WorkOrderId,@F_FileId,@F_Type,@F_Id)");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_FileId", SqlDbType.Int,4),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_WorkOrderId;
            parameters[1].Value = model.F_FileId;
            parameters[2].Value = model.F_Type;
            parameters[3].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_WorkFile model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_WorkFile set ");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Id=@F_Id");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId and F_FileId=@F_FileId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4),
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Type;
            parameters[1].Value = model.F_Id;
            parameters[2].Value = model.F_WorkOrderId;
            parameters[3].Value = model.F_FileId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(string F_WorkOrderId, int F_FileId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_WorkFile ");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId and F_FileId=@F_FileId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)          };
            parameters[0].Value = F_WorkOrderId;
            parameters[1].Value = F_FileId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
		/// 删除一条数据
		/// </summary>
		public bool DeleteList(string F_FileIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_WorkFile ");
            strSql.Append(" where F_FileId in (" + F_FileIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_WorkFile GetModel(string F_WorkOrderId, int F_FileId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_WorkOrderId,F_FileId,F_Type,F_Id from T_Sys_WorkFile ");
            strSql.Append(" where F_WorkOrderId=@F_WorkOrderId and F_FileId=@F_FileId ");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_WorkOrderId", SqlDbType.NVarChar,20),
                    new SqlParameter("@F_FileId", SqlDbType.Int,4)          };
            parameters[0].Value = F_WorkOrderId;
            parameters[1].Value = F_FileId;

            CallCenterApi.Model.T_Sys_WorkFile model = new CallCenterApi.Model.T_Sys_WorkFile();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_WorkFile DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_WorkFile model = new CallCenterApi.Model.T_Sys_WorkFile();
            if (row != null)
            {
                if (row["F_WorkOrderId"] != null)
                {
                    model.F_WorkOrderId = row["F_WorkOrderId"].ToString();
                }
                if (row["F_FileId"] != null && row["F_FileId"].ToString() != "")
                {
                    model.F_FileId = int.Parse(row["F_FileId"].ToString());
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_WorkOrderId,F_FileId,F_Type,F_Id ");
            strSql.Append(" FROM T_Sys_WorkFile ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_WorkOrderId,F_FileId,F_Type,F_Id ");
            strSql.Append(" FROM T_Sys_WorkFile ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_WorkFile ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_FileId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_WorkFile T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_WorkFile";
			parameters[1].Value = "F_FileId";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

